const CaseDescriptionItem = {
  name: 'CaseDescriptionItem',
  props: {
    label: {
      type: String,
      default: ''
    }
  },
  template: `
       <div class="case-description--label">
         {{ getLabel }}
       </div>
       <div class="case-description--text">
         <slot></slot>    
       </div>
  `,
  computed: {
    getLabel() {
      return this.label ? `${this.label}：` : this.label
    }
  }
}
