const VanFieldLabel = {
    name: 'VanFieldLabel',
    props: {
      required: [String, Boolean, null, undefined]
    },
    template: `<div class="van-field__label--row">
                 <div :class="{'van-field-title': true,  'van-field-required': required !== false }">
                    <slot></slot>
                 </div>
                 <div v-if="$slots.labelRight" class="van-field-right">
                   <slot name="labelRight"></slot>
                 </div>
               </div>`,
    mounted() {
        console.log(this.required)
    }
}
