function sendMessage (data) {
  if (!window) return
  window.parent.postMessage(data, '*')
}
const constantConfig = {
  // 选择  目前只有 交通 1个
  fy_options: [
    { value: '49', label: '新区交通综合信息服务系统' }
  ],
  // 申请立案时， 所要上传的材料类型
  fy_case_type: [
    { value: '6', label: '执行立案-申请执行书' },
    { value: '7', label: '保全申请书' },
    { value: '8', label: '立案受理通知书' },
    { value: '9', label: '裁判文书' },
    { value: '10', label: '生效证明' },
    { value: '11', label: '其他' },
    { value: '12', label: '上诉状' },
    { value: '13', label: '答辩状' }
  ],
  // 政治面貌
  fy_political_outlook: [
    { value: '0', label: '群众' },
    { value: '1', label: '共青团员' },
    { value: '2', label: '中共党员' },
    { value: '3', label: '中共预备党员' },
    { value: '4', label: '民革党员' },
    { value: '5', label: '民盟盟员' },
    { value: '6', label: '民建会员' },
    { value: '7', label: '民进会员' },
    { value: '8', label: '农工党党员' },
    { value: '9', label: '致公党党员' },
    { value: '10', label: '九三学社社员' },
    { value: '11', label: '台盟盟员' },
    { value: '12', label: '无党派人士' }
  ],
  //    性别
  fy_sexs: [
    { value: '0', label: '男' },
    { value: '1', label: '女' },
    { value: '2', label: '其他' }
  ],
  // 证件类型
  fy_certificates: [
    { value: '0', label: '中华人民共和国身份证' },
    { value: '1', label: '军官证' },
    { value: '2', label: '士兵证' },
    { value: '3', label: '学生证' },
    { value: '4', label: '警官证' },
    { value: '5', label: '工作证' },
    { value: '6', label: '中国公民护照' },
    { value: '7', label: '港澳通行证' },
    { value: '8', label: '香港永久性居民身份证' },
    { value: '9', label: '律师证' },
    { value: '10', label: '香港居民身份证' },
    { value: '11', label: '澳门特别行政区永久性居民身份证' },
    { value: '12', label: '澳门特别行政区非永久性居民身份证' },
    { value: '13', label: '机动车驾驶证' },
    { value: '14', label: '台湾居民来往大陆通行证' },
    { value: '15', label: '外国公民护照' },
    { value: '16', label: '户口簿' }
  ],
  // 民族
  fy_nations: [
    { value: '55', label: '汉族' },
    { value: '1', label: '回族' },
    { value: '0', label: '蒙古族' },
    { value: '2', label: '藏族' },
    { value: '3', label: '维吾尔族' },
    { value: '4', label: '苗族' },
    { value: '5', label: '彝族' },
    { value: '6', label: '壮族' },
    { value: '7', label: '布依族' },
    { value: '8', label: '朝鲜族' },
    { value: '9', label: '满族' },
    { value: '10', label: '侗族' },
    { value: '11', label: '瑶族' },
    { value: '12', label: '白族' },
    { value: '13', label: '土家族' },
    { value: '14', label: '哈尼族' },
    { value: '15', label: '哈萨克族' },
    { value: '16', label: '傣族' },
    { value: '17', label: '黎族' },
    { value: '18', label: '僳僳族' },
    { value: '19', label: '佤族' },
    { value: '20', label: '畲族' },
    { value: '21', label: '高山族' },
    { value: '22', label: '拉祜族' },
    { value: '23', label: '水族' },
    { value: '24', label: '东乡族' },
    { value: '25', label: '纳西族' },
    { value: '26', label: '景颇族' },
    { value: '27', label: '柯尔克孜族' },
    { value: '28', label: '土族' },
    { value: '29', label: '达斡尔族' },
    { value: '30', label: '仫佬族' },
    { value: '31', label: '羌族' },
    { value: '32', label: '布朗族' },
    { value: '33', label: '撒拉族' },
    { value: '34', label: '毛南族' },
    { value: '35', label: '仡佬族' },
    { value: '36', label: '锡伯族' },
    { value: '37', label: '阿昌族' },
    { value: '38', label: '普米族' },
    { value: '39', label: '塔吉克族' },
    { value: '40', label: '怒族' },
    { value: '41', label: '乌孜别克族' },
    { value: '42', label: '俄罗斯族' },
    { value: '43', label: '鄂温克族' },
    { value: '44', label: '德昂族' },
    { value: '45', label: '保安族' },
    { value: '46', label: '裕固族' },
    { value: '47', label: '京族' },
    { value: '48', label: '塔塔尔族' },
    { value: '49', label: '独龙族' },
    { value: '50', label: '鄂伦春族' },
    { value: '51', label: '赫哲族' },
    { value: '52', label: '门巴族' },
    { value: '53', label: '珞巴族' },
    { value: '54', label: '基诺族' }
  ],
  // 国籍
  fy_nationalitys: [
    { value: '0', label: '中国' },
    { value: '1', label: '美国' }
  ],
  fy_lawsPeople_types: [
    { value: '0', label: '律师' },
    { value: '1', label: '承担法律援助的律师' },
    { value: '2', label: '监护人' },
    { value: '3', label: '亲友' },
    { value: '4', label: '人民团体推荐的人' },
    { value: '5', label: '所在单位推荐的人' },
    { value: '6', label: ' 许可的其他公民' },
    { value: '7', label: '法律工作者' },
    { value: '8', label: '工作人员' }
  ],
  fy_agentTypes: [
    { value: '0', label: '律师' },
    { value: '1', label: '承担法律援助的律师' },
    { value: '2', label: '监护人' },
    { value: '3', label: '亲友' },
    { value: '4', label: '人民团体推荐的人' },
    { value: '5', label: '所在单位推荐的人' },
    { value: '6', label: ' 许可的其他公民' },
    { value: '7', label: '法律工作者' },
    { value: '8', label: '工作人员' }
  ],
  fy_manage_baseOn: [
    { value: '0', label: '被告（被申请人）住所地' },
    { value: '1', label: '被告（被申请人）劳动教养地' },
    { value: '2', label: '协议管辖' },
    { value: '3', label: '指定管辖' },
    { value: '4', label: '被告（被申请人）注册登记地' },
    { value: '5', label: '被告（被申请人）主要营业地' }
  ],
  fy_partiesType: [
    { value: '0', label: '自然人' },
    { value: '1', label: '法人' },
    { value: '2', label: '非法人组织' }
  ],
  fy_evidenceType: [
    { value: '0', label: '原件' },
    { value: '1', label: '复印件' },
    { value: '2', label: '电子打印件' }
  ],
  fy_owner: [
    { value: '0', label: '范海辛' },
    { value: '1', label: '李秀丽' },
    { value: '2', label: '朱丽玲' }
  ],
  fy_case_origin: [
    { value: '1', label: '民事' },
    { value: '2', label: '行政' },
    { value: '3', label: '执行' }
  ],
  fy_property_type: [
    { value: '1', label: '货币现金' },
    { value: '2', label: '存款' },
    { value: '3', label: '交通运输工具' },
    { value: '4', label: '房产' },
    { value: '5', label: '土地使用权' },
    { value: '6', label: '股票' },
    { value: '7', label: '基金' },
    { value: '8', label: '债券' },
    { value: '9', label: '股权' },
    { value: '10', label: '债权' },
    { value: '11', label: '机器设备' },
    { value: '12', label: '产品、原材料' },
    { value: '13', label: '知识产权' },
    { value: '14', label: '古玩字画' },
    { value: '15', label: '森林、林木所有权' },
    { value: '16', label: '集体土地所有权' },
    { value: '17', label: '珠宝玉石首饰' },
    { value: '18', label: '探矿、采矿权' },
    { value: '19', label: '船舶' },
    { value: '20', label: '船载货物' },
    { value: '21', label: '船用物料' },
    { value: '22', label: '船载货物' },
    { value: '23', label: '留置的货物' },
    { value: '24', label: '其他' },
  ],
  // 币种
  fy_currency: [
    { label: '人民币', value: '1' },
    { label: '港币', value: '2' },
    { label: '美元', value: '3' },
    { label: '英镑', value: '4' },
    { label: '欧元', value: '5' }
  ],
  // 车辆类型
  fy_carType: [
    { label: '新能源汽车', value: '1' },
    { label: '微型汽车', value: '2' },
    { label: '小型汽车', value: '3' },
    { label: '紧凑型汽车', value: '4' },
    { label: '中型汽车', value: '5' },
    { label: '中大型汽车', value: '6' },
    { label: '大型汽车', value: '7' },
    { label: 'SUV', value: '8' },
    { label: 'MPV', value: '9' },
    { label: '跑车', value: '10' },
    { label: '其他', value: '11' },
  ]
}
function isArray (arr) {
  return Object.prototype.toString.call(arr) === '[object Array]'
}
function deepClone (obj) {
  // 对常见的“非”值，直接返回原来值
  if ([null, undefined, NaN, false].includes(obj)) return obj
  if (typeof obj !== 'object' && typeof obj !== 'function') {
    // 原始类型直接返回
    return obj
  }
  const o = isArray(obj) ? [] : {}
  for (const i in obj) {
    if (obj.hasOwnProperty(i)) {
      o[i] = typeof obj[i] === 'object' ? deepClone(obj[i]) : obj[i]
    }
  }
  return o
}
function stringFyJson (value) {
  if (!value) {
    return value
  }
  if (typeof value === 'object') { return JSON.stringify(value) }
  return value
}
function parseJsonBack (value) {
  if (typeof value === 'string') {
    try {
      const obj = JSON.parse(value)
      if (obj && typeof obj === 'object') {
        return obj
      } else {
        return value
      }
    } catch (e) {
      return value
    }
  } else {
    return value
  }
}
function getAgeByDateTime (dateTime, currentDate) {
  // eslint-disable-next-line no-undef
  if (!$validate.isDate(currentDate)) {
    throw new Error('currentDate is not a format Date')
  }
  // eslint-disable-next-line no-undef
  if (!$validate.isDateISO(dateTime)) {
    throw new Error('dateTime is not a format dateString')
  }
  const dateTimeArr = dateTime.split('-')
  // 今天日期，数组，同 birthday
  const today = [currentDate.getFullYear(), currentDate.getMonth() + 1, currentDate.getDate()]
  // 分别计算年月日差值
  const age = today.map((value, index) => {
    return value - dateTimeArr[index]
  })
  // 当天数为负数时，月减 1，天数加上月总天数
  if (age[2] < 0) {
    // 简单获取上个月总天数的方法，不会错
    const lastMonth = new Date(today[0], today[1], 0)
    age[1]--
    age[2] += lastMonth.getDate()
  }
  // 当月数为负数时，年减 1，月数加上 12
  if (age[1] < 0) {
    age[0]--
    age[1] += 12
  }
  return age
}
// 数字汉字
function numberTransferChinese (num) {
  // 可继续追加更高位转换值
  if (!num || isNaN(num)) {
    return '零'
  }
  const arr1 = ['零', '一', '二', '三', '四', '五', '六', '七', '八', '九']
  const arr2 = ['', '十', '百', '千', '万', '十', '百', '千', '亿', '十', '百', '千', '万', '十', '百', '千', '亿']
  const english = num.toString().split('')
  let result = ''
  for (let i = 0; i < english.length; i++) {
    const des_i = english.length - 1 - i// 倒序排列设值
    result = arr2[i] + result
    var arr1_index = english[des_i]
    result = arr1[arr1_index] + result
  }
  // 将【零千、零百】换成【零】 【十零】换成【十】
  result = result.replace(/零(千|百|十)/g, '零').replace(/十零/g, '十')
  // 合并中间多个零为一个零
  result = result.replace(/零+/g, '零')
  // 将【零亿】换成【亿】【零万】换成【万】
  result = result.replace(/零亿/g, '亿').replace(/零万/g, '万')
  // 将【亿万】换成【亿】
  result = result.replace(/亿万/g, '亿')
  // 移除末尾的零
  result = result.replace(/零+$/, '')
  // 将【零一十】换成【零十】
  // result = result.replace(/零一十/g, '零十');//貌似正规读法是零一十
  // 将【一十】换成【十】
  result = result.replace(/^一十/g, '十')
  return result
}
function useUrlQuery (queryName) {
  const reg = new RegExp("(^|&)" + queryName + "=([^&]*)(&|$)", "i");
  const r = window.location.search.substr(1).match(reg);
  if (r != null) {
    return decodeURI(r[2]);
  } else {
    return null;
  }
}
function createApp (Vue, config) {
  const env = useUrlQuery('n')
  const app = new (Vue || window.Vue)(config)
  if (env === 'D') {
    return app
  } else {
    return null
  }
}
