const UploadCustomTips = {
  name: 'UploadCustomTips',
  props: {
    firstText: {
      type: String,
      default: '同类型案件最多上传20个，且每个文件大小不得超过80MB。'
    }
  },
  template: `
  <div class="upload-tips">
    <div class="upload-tps--title">
      <i class="el-cion el-icon-warning"></i>注意事项
    </div>
    <div class="upload-tips--content text-indent2">
      <p>1.{{ firstText }}</p>
      <p>2.您上传的图像材料请满足如下要求：</p>
      <div class="text-indent3">
        <p><span>①</span>图片无黑边；</p>
        <p><span>②</span>内容清晰完整；</p>
        <p><span>③</span>图片方向调整至正向；</p>
        <p><span>④</span>拍摄照片请在单一颜色背景下平整摆放材料水平拍摄。</p>
      </div>
      <p>3.建议将同一份材料的多个文件合成一个pdf后再上传。</p>
      <p>4.请上传.doc,.docx,.rar,.zip,.jpeg,.jpg,.png,.pdf,.xlsx,.xls格式文件。</p>
    </div>
   </div>
  `
}
