/* h5弹窗 */
function vantToast(msg) {
    window.parent.postMessage(
        {
            cmd: 'warnInfo',
            params: {
                type: 'text',
                message: msg
            }
        },
        '*'
    )
}
/* 判断是否为移动端 */
function isMobile() {
    return navigator.userAgent.match(
        /(iPhone|iPod|Android|ios|iOS|iPad|Backerry|WebOS|Symbian|Windows Phone|Phone)/i
    )
}
function parentIframeScroll(e) {
    e.scrollIntoView({
        behavior: 'smooth'
    })
}
function findParentNodeNextForm(node, result) {
    if (node.parentNode.tagName === 'FORM') {
        result && result(node)
    } else {
        findParentNodeNextForm(node.parentNode, result)
    }
}
/* 第一个校验出错的表单项的class类  vant规定 */
const fieldErrorItemClass = '.van-field--error'
function scrollFistErrorAndShowToast(element = document) {
    // 创建跳转链接 适用window.scroll 来进行跳转
    const errFirst = element.querySelector(
        fieldErrorItemClass
    )
    if (!errFirst) {
        return
    }
    errFirst.scrollIntoView({
        behavior: 'smooth'
    })
    /* 所有校验错误信息隐藏，获取其中的文本弹出提示 */
    const errorMessage = errFirst.querySelector('.van-field__error-message')
    if (isMobile()) {
        errorMessage && vantToast(errorMessage.innerText)
    } else {
        errorMessage && vantToast(errorMessage.innerText)
    }
}
